== Change Log

===  5.1.0.0-fuse
* AMQ-1848 - TransportConnection MBeans leaked on duplex network connector disconnect (MB-354)
* AMQ-1585 - Problems with pure master/slave configuration - additional fix (MB-369)
* MB-353: xbean broker sslContext with multiple brokers  verify sslContext
* MB-254: Support for more graceful handling of timeouts within MessageProducer.send (AMQ-1517)

===  5.0.0.17-fuse
* AMQ-1834 - Hash Resize issue for message store (MB-370)
* AMQ-1585 - Problems with pure master/slave configuration (MB-369)

===  5.0.0.16-fuse
* MB-368: Persistent store indexes not being cleaned up at runtime (when using durable subscriber connected to a downstream broker)
* AMQ-1797: persistent messages for durable subscribers are not purged from disc storage (MB-366)
* AMQ-1814: IndexManager keeps an inaccurate free list
* AMQ-1819: Deadlock occurs with a duplex network connection.

===  5.0.0.15-fuse
* MB-361: Acknowledgment of Messages consumed from VirtualTopic consumer queues fails
* MB-357: Decouple ssl context activation from the TransportFactory.
* MB-355: When consuming using springs DMLC with cacheLevel=1 messages can be lost
* MB-360: Error in directory.mkdirs is masked and can result in FileNotFoundException when creating tmp_storage directory
* AMQ-1749: SSL configuration now does not conflict when multiple broker are configured in a single JVM
* AMQ-1742: False positives from ConnectionAudit duplicateChecker when there are gaps in the message sequences received by a consumer
* ESB-166: Fixes shutdown error in smx. Was caused by the way Jencks shuts down endpoints.
* AMQ-1738: Messages stuck in a queue don't get dispatch (happens when consumers close out)
* AMQ-1542: NetworkConnector parameters are not passed back over a duplex connection
* AMQ-1661: Duplicate messages and extra network traffic with duplex connections
* AMQ-1732: Add an Individual acknowledge mode for message consumption
* AMQ-1733: Add an option to allow the xbean broker to destroy the spring application context when the broker is stopped

===  5.0.0.14-fuse
* MB-321: Enable SSL without using system properties
* MB-341: activemq-admin create behaves differently on Linux and Windows
* MB-346: Slow leak in AmqPersistenceAdapter DataFileAppender.inflightWrites Map
* MB-345: AmqPersistenceAdapter race condition results in java.io.FileNotFoundException: (File exists)
* MB-340: DefaultDatabaseLocker causes Oracle to throw an exception "maximum open cursors exceeded" under heavy load (AMQ-1702)
* AMQ-1690: QuickJPAStoreRecoveryBrokerTest.testQueueNonPersistentMessagesLostOnRestart sometimes fails, timing issue with broker shutdown
* AMQ-1689: This reduces the the number of disk syncs that the broker does on some workloads which increases performance
* AMQ-1696: Restore the setConnectionFactory() method on the ActiveMQResourceAdapter
* AMQ-1701: Exception on publishing persistent (disk persistence) message once consumer comes up.
* AMQ-1702: DefaultDatabaseLocker causes Oracle to throw an exception "maximum open cursors exceeded" under heavy load
* AMQ-1698: AMQ Threads prevent clean jvm termination
* AMQ-1509: Duplicate topic messages received with network of brokers and selectors
* AMQ-1542: NetworkConnector parameters are not passed back over a duplex connection
* AMQ-1705: Deadlock between VMTransport and QueueThread
* AMQ-1699: TCPConnector doesn't listen on socket after stopping then starting it again...
* CAMEL-505: Added refactor to make it easier to create endpoint instances from a spring.xml with minimal constructors
* AMQ-1720: added the ability to get a callback when the broker is shutdown.  Also added an option to System.exit when the broker is shutdown. (MB-352)
* AMQ-1714: Messages get dispatched to a removed consumer, locked and remain unavailable - appear as missing
* AMQ-1724: Allow ssl context configuration through spring/xbean (MB-342)
* AMQ-1728: The bin/linux-*/activemq script is missing.
* AMQ-1727: java.lang.IllegalStateException: Timer already cancelled caused by Exception in thread "ActiveMQ Scheduler" java.util.ConcurrentModificationException
* AMQ-1709: Network of Brokers Memory Leak Due to Race Condition
* AMQ-1731: Allow HashIndex bins to grow as needed in Kaha

===  5.0.0.13-fuse
* AMQ-1696: Restore the setConnectionFactory() method on the ActiveMQResourceAdapter

===  5.0.0.12-fuse
* AMQ-1098: Use of https transport throws ClassCastException
* AMQ-1686: Small window in wakeup logic for PooledTaskRunner - task can get executed in parallell
* AMQ-1681: Memory leak when creating large numbers of Temporary Destinations (Log4J related)
* AMQ-1315: RSS/Atom Feed does not work in the WebConsole
* AMQ-1013: Web console does not escape message details (/activemq-web-console/message.jsp)
* AMQ-1685: activemq-admin start does not work on windows.
* AMQ-1683: possible dynamic instability in AMQStore indexes
* AMQ-1654: Mirror Topics for temorary queues
* AMQ-1678: JMX methods exposed for a Queue dont work right
* AMQ-1200: XA fails to start when JCA rar re-establishes connectivity with an external broker (tcp transport)
* AMQ-1667: AMQ message store throws IllegalStateException/IndexOutOfBoundsExceptions
* AMQ-1103: Prefetch size < 0 should throw an exception somewhere or be defaulted, as messages are not dispatched anymore
* AMQ-1254: Kaha Store puts a non-string into System properties
* AMQ-1255: Advisory queues don't disappear for TEMPORARY queues/topics
* AMQ-1345: XBean annotation 'resourceAdapter' is specified twice
* AMQ-1381: Client Certificates do not work due to incorrectly overriden method in SslTransport.java
* AMQ-1438: When in XA Transaction Active-MQ integrated with OpenEJB hangs in the isSameRM method of LocalAndXATransaction. 
* AMQ-1451: FailoverTransport bad handling of InterruptedException in wait loop.
* AMQ-1456: JMS to JMS Bridge property consumerName on InboundTopicBridge element dont work
* AMQ-1465: Regression with networkConnector 'name' attribute
* AMQ-1487: Bug in ActiveMQSession::send() prevents non-persistent messages from being sent sync
* AMQ-1488: Bug in FailoverTransport results in messages that have been queued during a network interruption being sent out of order upon call to restoreTransport()
* AMQ-1489: discoveryUri in transportConnector and uri in networkConnector partially ignored if multicast
* AMQ-1511:  Slave starts connectors before master fails
* AMQ-1517: Support for more graceful handling of timeouts within MessageProducer.send
* AMQ-1578: No exposure to the 'idleTimeout' property for ConnectionPool class, which makes it difficult to implement keepAlive semantics on PooledConnections
* AMQ-1587: Improvements/Bug Fixes for LDAP Discovery Mechanism (LDAP Network Connector)
* AMQ-1607: Static method to register TransportFactory
* AMQ-1616: JMS Compliance - Closing a closed connection should not throw an exception
* AMQ-1620: compositeTopic changing destination field of original message
* AMQ-1623: KahaMessageStore does not close or delete files for deleted destinations.
* AMQ-1624: Fileserver webapp wont work out of the box
* AMQ-1629: wildcards don't work in networkconnector excludeDestinations 
* AMQ-1631: Concurrency Issue in MessageConsumer's deliveredMessages within dispose
* AMQ-1635: Remove unused references to backport-util-concurrent
* AMQ-1640: variant of DeadLetterTest with message listener
* AMQ-1646: Change dispatchAsync = true for clients by default
* AMQ-1647: PooledTaskRunner fails to shutdown after task throws exception
* AMQ-1650: AmqPersistenceAdapter throws java.io.IOException: Failed to read to journal for: offset
* AMQ-1651: Sending message to deleted TemporaryQueue throws JMSException instead of IllegalDestinationException
* AMQ-1656: Messages are sometimes skipped when using JDBC master/slave
* AMQ-1659: SSL Transport configured in wantClientAuth mode never asks for the client certificate during the SSL Handshake
* AMQ-1665: SslBrokerTest that verifies the programetic setting of truststore etc and negates the need to use javax.net.ssl. system props 
* AMQ-1666: connection URI options not applied to both sides of VM transport
* AMQ-1669: AMQ Journal data files never deleted - exception in consolidateDataFilesNotIn()
* AMQ-1672: Mirror Queues on Temp Queues is causing Memory leak
* AMQ-1674: Default Persistence fails / MDBs stop processing in JBoss 4.2.2.GA
* AMQ-765: ActiveMQ RA serialization issue on Glassfish

===  5.0.0.11-fuse
* MB-335: Issues with NetworkBridgeViewMBean
* MB-322: Build MB 5.0.0.11 release
* MB-320: Update MB notices.txt for new dependencies
* MB-295: Broker support for dynamic cleanup of message reference store and durable subscriber indexes
* MB-297: AmqPersistenceAdapter throws java.io.IOException: Failed to read to journal for: offset (AMQ-1650)
* MB-289: Create a tool to allows you to inspect Journal files for auditing purposes.
* MB-280: MBean Configuration Syntax
* AMQ-1345: XBean annotation 'resourceAdapter' is specified twice

===  5.0.0.10-fuse 
* MB-311: Out of Order message deliver to a Consumer using a MessageListener
* MB-310: Using message expiration feature can cause a queue to stop sending messages to consumers
* MB-300: Sending persistent messages to a broker who has persistence disabled hangs the broker after a short period of time. 
* AMQ-499: Support for delayed/scheduled delivery of messages.
* AMQ-451: allow scheduled delivery of messages
* AMQ-1636: the ActiveMQ camel component should default to using a SingleConnectionFactory to avoid creating tons of connections when sending messages in Camel - or support PooledConnectionFactory if enabled
* AMQ-1633: Temporary destinations not being cleaned up upon delete() when using network of brokers
* AMQ-1618: Improper handling of container restrictions in creation of sessions
* AMQ-1613: Inactivity monitor blocks trying to close out a Failover transport that is in the middle of send.
* AMQ-1563: upgrade to Camel 1.3.0 and Spring 2.5.1 or later
* AMQ-1283: Messages aren't being delivered in a clustered environment
* AMQ-1199: provide a new simple API so end users can view available destinations and query them to find their statistics (such as queue depth etc)
* AMQ-1186: Notify user when listening on unstarted connection
* AMQ-122: add support for priority message ordering
* MB-307: Messages not being delivered if one out of two consumers get closed.
* AMQ-1603: EOFExceptions and Broken Pipe exceptions 

===  5.0.0.9-fuse
* MB-287: Deadlock when dequeueing messages from a Queue (when have pool of producers and pool of consumers)
* MB-275: JMX console displays negative QueueSize on broker restart (when have persisted messages in queue)
* AMQ-1602: Missing logging-commons.jar contents in activemq-all-5.0.0.jar
* AMQ-1598: Extraneous Thread.dumpStack() method in ProducerEventSource.java
* AMQ-1597: Upgrade to Jettison 1.0
* AMQ-1591: When using a JDBC based database locker in an Master/Slave configuration, the lock is not updated.
* AMQ-1584: ClassLoadingAwareObjectInputStream cannot load primary classes
* AMQ-1583: Creating a durable subscriber throws ConcurrentModificationException
* AMQ-1580: ArrayOutOfBoundsException in ActiveMQInputStream
* AMQ-1576: ActiveMQMessageTransformation.copyProperties NullPointerException
* AMQ-1574: FailoverTransport logs routine reconnects at INFO/WARN instead of DEBUG
* AMQ-1565: Exception String from BrokerFactory has a typo - "Could load " should presumably read "Could not load "
* AMQ-1564: Deadlock between VMTransport threads accessing AMQStore
* AMQ-1558: wrapper.conf issue so Java Service Wrapper doesn't start on windows
* AMQ-1544: ERROR RecoveryListenerAdapter - Message id xxxxxx could not be recovered from the data store! (when using Spring's DefaultMessageListenerContainer with more than 1 concurrentConsumers to dispatch JMS messages)
* AMQ-1542: NetworkConnector parameters are not passed back over a duplex connection
* AMQ-1506: System.out in source code: org.apache.activemq.ra.ServerSessionPoolImpl
* AMQ-1383: org.apache.activemq.transport.InactivityMonitor$1 cannot be cast to edu.emory.mathcs.backport.java.util.concurrent.Delayed
* AMQ-1367: Messages received count is wrong in web console
* AMQ-1360: I saw this test failure on a CI build in org.apache.activemq.broker.region.cursors.CursorDurableTest
* AMQ-1296: Already delivered (and deleted from persistence store) messages are available through JMX queue operations
* AMQ-1271: Queue size is 0, after starting with messages in persisent storage
* AMQ-1083: Heap overflow when durable consumer closes
* AMQ-765: ActiveMQ RA serialization issue on Glassfish
* AMQ-1503: OutOfMemoryError in ActiveMQ message broker when attempting to publish 2 Million messages - one publisher and four durable subscribes (AMQ-914)
* AMQ-1477: Simplify the DiscoveryAgent interface
* MB-293: HTTP Discovery agent does not recover from a connection error

===  5.0.0.8-fuse
* MB-290: Clients do not shutdown due to non-daemon threads hanging around.
* AMQ-943: Pluggable Stomp Message Mapping
* AMQ-1493: Upgrade XStream to 1.2.2
* AMQ-1361: Logging improvement contribution
* AMQ-1552: add a spring factory bean to make it easy to unify the failover policy across every ActiveMQConnectionFactory instance if the connection URL differs across parts of your application
* AMQ-775: MessageAuthorizationPolicy doesn't work
* AMQ-1553: Queue structure pagedInMessages can hold upto 1000 messages for a long time
* AMQ-1556: Concurrency Issue on MessageConsumer deliveredMessages
* AMQ-1510: Incorrect value for QueueCount attribute after broker restart
* AMQ-1559: AMQStore cannot resolve message references for Durable Topic Subscribers
* AMQ-1560: amqPersistence store grows continuously
* AMQ-1475: deadlock in Usage & Topic
* AMQ-1562: Queue Pending Message Cursor doesn't adequately release cache when no space left
* AMQ-1566: Out of order messages can be dispatched out of order for durable topic subscriptions under load
* AMQ-1572: Add the option for a backup channel that is already connected for the Failover transport
* AMQ-1116: deadlock when shutting down client that is configured with failover=true and is presently disconnected from broker
* AMQ-1575: FailoverTransport with MaxReconnectAttempts set does not recover quickly, when used with ConnectionPooling....
* AMQ-1577: FailoverTransport doesn't shut-down cleanly, complains about underlying transport going down
* AMQ-1581: PooledConnections don't initialize correctly when broker not available (causes problems with Failover)
* AMQ-1446: org.apache.activemq.store.memory.MemoryPersistenceAdapter - Expected an instance of MemoryMessageStore but was: org.apache.activemq.store.memory.MemoryTransactionStore$2@a0f3d1

===  5.0.0.7-fuse 
* MB-284: Upgrade to Camel 1.3.0.0-fuse 
* MB-283: Using PropertyPlaceHolderConfigurer to set the SystemUsage size limit property causes parsing error on startup
* AMQ-1535: missing lines in wrapper.conf
* AMQ-1533: Can not unsubscribe topic
* AMQ-1532: Fix service wrapper problems in linux
* AMQ-1531: Visualization page needs updating
* AMQ-1519: Broker Should be started async to avoid a slave broker from blocking the startup of J2EE server (like JBoss)
* AMQ-1509: Duplicate topic messages received with network of brokers and selectors
* AMQ-1365: Username and password field got swapped when calling PooledConnection.createConnection
* AMQ-1358: Make timestamp legible in web interface
* AMQ-1353: Broken URL
* AMQ-1328: Remove the log.error in VMTransport.asyncOneWay
* AMQ-1311: Expose brokerName via BrokerViewMBean
* AMQ-1231: Performance issues with org/apache/activemq/broker/region/PrefetchSubscription.java and org/apache/activemq/store/kahadaptor/KahaTopicMessageStore.java
* AMQ-400: DTD File Not Found
* MB-282: The activemq-all jar file is missing the required dependency on commons-logging.
* AMQ-1528: HasPage overflow results in indexOutOfBoundsException in AMQStore
* AMQ-1525: InactivityMonitor incorrectly assumes there isn't activity on a Transport
* AMQ-1524: Thread name spelling mistake: "AcitveMQ Connection Worker"
* AMQ-1521: Acknowledgement of messages across a duplex network does not work correctly
* AMQ-1518: NetworkConnector is leaking a thread if broker disconnects
* AMQ-1515: Removed use of ClassLoading
* AMQ-1507: Shared Filesystem Master Slave not working
* AMQ-1272: Stomp protocol does not correctly check authentication (security hole)
* AMQ-1006: RoundRobinDispatchPolicy divides uneven
* AMQ-967: setting maximumRedeliveries to -1 is equivalent to maximumRedeliveries=0, but doc says otherwise
* AMQ-1512: InactivityMonitor hangs raising an exception
* AMQ-1501: Persitent Topic Messages will not be deletet if more then one durable subscriber is active on topic
* AMQ-1490: Deadlocks (with JUnit tests)
* MB-279: Error message in broker log: ERROR - org.apache.activemq.broker.TransportConnection.Service - Async error occurred: java.lang.IllegalStateException
* MB-274: Documentation for amqPersistenceAdapter's maxDataFileLength/maxFileLength setting

===  5.0.0.6-fuse 
* MB-281: Enhancement to provide maxStoreSize configuration for the AmqPersistenceAdapter
* MB-278: Stopped broker connections not getting cleaned up when broker thread hung on a memory limit
* MB-273: Bad default location for console install
* AMQ-1504: Bug in MapContainerImpl and DiskIndexLinkedList
* AMQ-1502: DiskIndexLinkedList incorrectly updates references when IndexItems are removed
* AMQ-1500: Recoverying the Kaha ReferenceStore can delete subscriber state
* AMQ-1496: jms.prefetchPolicy in Resource-Adapter!
* AMQ-1491: bug in TcpTransport.run() and stop() holds dead connections and prevents reconnects
* AMQ-1472: Unable to deliver messages through a mixed version broker network
* AMQ-1446: org.apache.activemq.store.memory.MemoryPersistenceAdapter - Expected an instance of MemoryMessageStore but was: org.apache.activemq.store.memory.MemoryTransactionStore$2@a0f3d1
* AMQ-1429: Package ActiveMQ as OSGi bundles instead of plain jars
* AMQ-1354: Exceptions are dropped by TransactionTemplate
* AMQ-1148: Fast producer, slow consumer hangs after a few messages when using VMPendingSubscriberMessageStoragePolicy
* MB-277: HTTP Based Discovery Agent

===  5.0.0.5-fuse 
* MB-263: As an "activemq-admin create broker-name" that creates a broker instance directory structure
* MB-257: Enabling memoryManager in activemq.xml causes "java.lang.ClassNotFoundException: usageManager"
* MB-256: Activemq.bat ACTIVEMQ_BASE fix
* MB-255: Memory leak in Network Connector reconnect logic
* MB-250: TransportDisposedIOException exception loop when adding NetworkConnector with invalid URL
* AMQ-1486: Allow message logs for AMQStore to ve archived instead of deleted when they are discarded
* AMQ-1485: Enable setting properties for sizing indexes used by the default reference store for AMQStore
* AMQ-1479: AMQ Store deletes data files which are in use
* AMQ-1468: Deadlock between ActiveMQTransport and ActiveMQScheduler
* AMQ-1467: Deadlock between FilePendingMessageCursor and MemoryUsage
* AMQ-1452: Duplicate messages dispatched when using AMQ Store
* AMQ-1449: Producer hangs on durable subscribe as Usage memory runs over
* AMQ-1445: RecoveryListenerAdapter - Message id ID... could not be recovered from the data store!
* AMQ-1444: Methods to support dynamic add/remove for connectors through JMX
* AMQ-1440: Allow minAckCount to have std set/get methods
* AMQ-1439: FanoutTransport minimum ack connection logic bug
* AMQ-1435: support mirrored queues to make it easier to monitor message flows via a topic (or queue via virtual topics) for things like BAM or monitoring etc
* AMQ-1434: allow the TransportListener to be configured on an ActiveMQConnectionFactory for easier working with Spring JmsTemplate / MessageListenerContainer
* AMQ-1389: Duplicate messages with durable subscribers and perstitent messages
* AMQ-1388: Make NetworkConnectors two-sided
* AMQ-1382: Unnecessary creation of /activemq-data/localhost/tmp_storage directory with AMQ 5.x
* AMQ-1370: allow a MesageListener to be passed into the createConsumer() method so that the consumer can be created with the correct MessageListener while the connection is started
* AMQ-1356: Durable Subscriptions do not work with Wildcards after broker is restarted.
* AMQ-1332: CLONE -Broker stops delivering messages to some consumers (AMQ-1251) (AMQ-1333)
* AMQ-1268: MarshallingBrokerTest.testQueueBrowserWith2Consumers() regression 
* AMQ-1251: Broker stops delivering messages to some consumers (AMQ-1333)
* AMQ-1250: 4.2 Broker memory leak wrt rejected incoming connections
* AMQ-1238: start script fails on Debian sarge
* AMQ-1205: Memory leak in Scheduler
* AMQ-1202: 4.2 Broker memory leak wrt network connectors
* AMQ-1156: option "wireFormat.tcpNoDelayEnabled=true" is ignored
* AMQ-1117: It would be helpful if some of the log messages that are logged at higher severity levels than they are presently
* AMQ-1095: Invalid messages selected from durable topic
* AMQ-1067: Stomp consumer not removed if client does not send disconnect message.
* AMQ-1046: Consolidate the ActiveMQ admin scripts to a single command line script
* AMQ-1038: Incorrect redelivery behavior and counters
* AMQ-907: Make the ActiveIO dependency and optional dependency.
* AMQ-875: TCP connector (server) will stop accepting connection if an invalid connection is made to him.
* AMQ-796: Client may shtudown when failover connection is reconnecting.  We need to maintain at least 1 non-daemon thread alive.
* AMQ-777: maxReconnectAttempts has no effect
* AMQ-670: STOMP not setting content-length on byte messages.
* AMQ-652: Potential infinite loop in ActiveMQ shutdown processing when in Geronimo
* AMQ-610: fix the test case FanoutTransportBrokerTest which is failing now due to the fix for AMQ-607 by making the open of the socket occur in the start() method
* AMQ-358: JNDI / LDAP discovery mechanism
* AMQ-327: Orphanded/lost queue messages in various failover tests in two broker configuration
* MB-262: Durable subscription messages not properly being acked
* MB-261: MarshallingSupport.unmarshalPrimitive is throwing "Unknown primitive type: 0" when nested map contains a null
* MB-258: Deadlock in Failover transport will hang a connection.

=== 5.0.0.4-fuse
* MB-248: Temp queue creation and use race condition
* MB-247: Closed STOMP connection are not properly being released by the broker / JMS Clients hang at initial connection
* MB-246: delete message not supported for web console (AMQ-1197)
* MB-245: provide a way of setting the timeToLive from the point in time the message is received by the broker to avoid clock sync issues (AMQ-1160)
* MB-244: security plugin to deal with temporary queue and topics better (AMQ-795)
* MB-243: Two TCP connection requirement for bidirectional message flow ... (AMQ-920)
* MB-242: AMQ Should Print a Warning (Or Throw an Exception) If Messages Are Received to a Non-Started Connection (AMQ-1253)
* MB-241: Authorization plugin should have configurable principal classes (AMQ-908)
* MB-240: Improve the InvalidClientIDException message so that we know where the previous connection was established from.  (AMQ-1341)
* MB-239: support JDBC master slave on MySQL (AMQ-1074)
* MB-238: web-console cannot connect to basic-auth JMX (AMQ-1260)
* MB-237: Broker should finish accepting connection in an async thread. (AMQ-1337)
* MB-236: Make WebConsole run as a standalone WAR (AMQ-1241)
* MB-235: JDBC Master Slave does not work on Sybase version 12.x (AMQ-1204)
* MB-234: Give the connection dispatcher threads names that are easy to associate with the peer. (AMQ-1339)
* MB-233: Network of brokers does not work via http (AMQ-137)
* MB-232: the apache-activemq.jar currently has millions of dependencies (as the assembly pom.xml has loads of dependencies to make the distribution). We need to split up making the uber-jar into another project (AMQ-1318)
* MB-231: Invalid Command Line Option Handling   (AMQ-1314)
* MB-230: support selectors in virtual destinations to allow a message to be dispatched to multiple phyiscal queues if it matches the selector (AMQ-1073)
* MB-229: Restart network bridges if they ever get stopped (AMQ-805)
* MB-228: Maven plugin could locate activemq-data directory in target dir (AMQ-1223)
* MB-227: JDBC master slave support for DB2 (AMQ-1193)
* MB-226: Expire messages at the Broker (AMQ-1056)
* MB-225: RegionBroker synchronization can deadlock when registering destinations (AMQ-1180)
* MB-224: Improve Kaha freeList (AMQ-1082)
* MB-223: Allow for use of a connect timeout property when creating socket (AMQ-186)
* MB-222: Enhance ActiveMQInput/Outputstream to use a real TCP connection. (AMQ-637)
* MB-221: Exclusive consumers are now selected up front when the consumer gets registered. (AMQ-1335)
* MB-220: Simplify SimpleAuthenticationPlugin Configuration (AMQ-1010)
* MB-219: Provide option to turn on//off AMQ statistics gathering (AMQ-894)
* MB-218: add a source distro to the maven2 build (AMQ-1091)
* MB-217: Avoid Network Deadlocks if possible (AMQ-1181)
* MB-216: Improve queue and durable subscription recovery performance. (AMQ-493)
* MB-215: Specify destination in responses from MessageListenerServlet (AMQ-1270)
* MB-214: ActiveMQ web component - proper handling of priority, timeToLive and delivery mode (AMQ-1227)
* MB-213: Add option to fork broker from maven plugin (AMQ-1222)
* MB-212: include the activemq-xmpp jar in the binary distro (AMQ-1151)
* MB-211: Allow org.apache.activemq.pool to support XA transactions (AMQ-1084)
* MB-210: expired messages should be sent to some kind of dead letter queue (AMQ-450)
* MB-209: HttpClientTransport does not allow configuring http proxy host/port (AMQ-1099)
* MB-208: Transactional Kaha Store (AMQ-1064)
* MB-207: ActiveMQ bridging - and how to set JMSDestination on a message when sending (AMQ-1232)
* MB-206: TEST org.apache.activemq.usecases.ThreeBrokerTopicNetworkUsingTcpTest FAILED (AMQ-477)
* MB-205: MessageExpirationTest..testMessagesInLongTransactionExpire() Persistent Message to Queue Regressoin. (AMQ-1269)
* MB-204: ActiveIOTransportChannelTest hangs on dual opterons with Java 5 (AMQ-295)
* MB-203: org.apache.activemq.spring.SpringTest.testSenderWithSpringXmlUsingSpring2NamespacesWithEmbeddedBrokerConfiguredViaXml (AMQ-1002)
* MB-202: Expired Message Listener (AMQ-1207)
* MB-201: SpringTest hangs (AMQ-616)
* MB-200: Using a very simple producer and consumer messages are received in wrong order. (AMQ-729)
* MB-199: ReliableReconnectTest is failing due to a NullPointerException (AMQ-1349)
* MB-198: fix test cases MultipleTestsWithSpring*Test which seem to fail due to another test keeping a broker/journal open (AMQ-626)
* MB-197: add Camel support in the activemq.xml file to show folks how to easily enable camel routes... (AMQ-1307)
* MB-196: Allow NetworkConnections to bi-directional (AMQ-979)
* MB-195: XStream message transformer that works in both directions (AMQ-1208)
* MB-194: Expose connection id of a connection via JMX (AMQ-1175)
* MB-193: 'reliable' does not work for http (AMQ-321)
* MB-192: support for BlobMessage to allow easy transfer of attachments (AMQ-1055)
* MB-191: Expired messages should trigger an advisory message (AMQ-880)
* MB-190: startup destinations don't work when using a security policy (AMQ-1157)
* MB-189: Display the establised Neteowork Connector Bridges via JMX (AMQ-1299)
* MB-188: support spool to disk for non-persistent topic consumers (AMQ-791)
* MB-187: allow a broker to be configured using a properties file (AMQ-1206)
* MB-186: be able to interact with the broker via messaging (AMQ-1051)
* MB-185: create Java Service Wrapper for ActiveMQ (AMQ-644)
* MB-184: Time in queue statistics handy (AMQ-567)
* MB-183: support for BlobMessage interface to support in-band and out-of-band file transfer (AMQ-1075)
* MB-182: Using temporary destination across a nework of broker not reliable. (AMQ-1176)
* MB-181: host the Web Console in the broker when running the 'activemq' script   (AMQ-1194)
* MB-180: allow a MessageTransformer to be registered with a producer or consumer to help transform a message going onto the bus or coming off the bus (AMQ-1053)
* MB-179: Destination statistics message count is not decremented after message expired (AMQ-879)
* MB-178: Bug in STOMP transport unsubscribe (AMQ-1077)
* MB-177: Failing to acquire exclusive lock - MySQL and other strange errors (AMQ-1236)
* MB-176: Kaha crashes after database recovery looking for "data--2" (AMQ-1264)
* MB-175: JMX Registration Issue (AMQ-680)
* MB-174: Deadlock in ActiveMQ Failover Worker (AMQ-897)
* MB-173: Upgrade to xbean 3.0 breaks build (AMQ-1259)
* MB-172: ActiveIO compromises java.lang.System.properties (AMQ-704)
* MB-171: RemoveSubscriptionInfo has incorrect openwire annotation in its header (AMQ-1284)
* MB-170: Remove reference to LogicBlaze from ActiveMQ --version command  (AMQ-1306)
* MB-169: Unexpected IllegalStateException when using the VMPendingQueueMessageStoragePolicy (AMQ-1346)
* MB-168: PooledConnectionFactory / PooledSession generates UnsupportedOperationException when publishing to a topic (AMQ-1161)
* MB-167: multi-threaded issues with failover transport (AMQ-750)
* MB-166: Ack range checking, etc. (AMQ-1081)
* MB-165: Deadlock in Queue.java (AMQ-1070)
* MB-164: Warning when using  multicast discoveryUri (AMQ-1089)
* MB-163: Upgrade to xbean 2.8 to fix invalid generated schemas (AMQ-1107)
* MB-162: ConduitBridge can malfunction when first of a set of consumers goes away (AMQ-776)
* MB-161: Using a selector provides invalid output (AMQ-1097)
* MB-160: createTemporaryQueue hangs (AMQ-1278)
* MB-159: RegionBroker resets JMS Timestamp (AMQ-1165)
* MB-158: Wrong message removed from store when using composite destinations (AMQ-959)
* MB-157: Deadlock in PrefetchSubscription (AMQ-1108)
* MB-156: Setting "time to live" to >0 fails delivery from linux to window (AMQ-975)
* MB-155: transportConnector using multicast (AMQ-944)
* MB-154: activemq-web module fails in maven-build with test enabled (AMQ-1039)
* MB-153: got an exception when running AMQStackOverFlowTest which causes the test suite to hang! (AMQ-1291)
* MB-152: InactivityMonitor: Transport connection disconnected "Channel was inactive for too long." (AMQ-1146)
* MB-151: MulticastDiscoveryAgent heart beast may stop of machine clock jumps around. (AMQ-1173)
* MB-150: Durable topic message delivery to restarted consumer results in messages out of order. (AMQ-1201)
* MB-149: Thread.currentThread().getContextClassLoader() null in FactoryFinder.newInstance (AMQ-1229)
* MB-148: spelling error (AMQ-1305)
* MB-147: Spring AspectJ autoproxying breaks ActiveMQManagedConnectionFactory injection (AMQ-1147)
* MB-146: Thread gets stuck in a WAIT and never returns (AMQ-1340)
* MB-145: Maven build doesn't fail even when maven plugin fails to start broker (AMQ-1224)
* MB-144: TransportConnector get duplicated when used with JMX (AMQ-1029)
* MB-143: Missing pom.xml (AMQ-1262)
* MB-142: bug in reading temp queue using the tempDestinationAuthorizationEntry  feature (AMQ-1163)
* MB-141: activem.conf: Use ${activemq.base} instead of .. (AMQ-1122)
* MB-140: web-console broken (queue browsing). (AMQ-1036)
* MB-139: Problem with subscription passing with network of brokers in AMQ 4.0.2 (AMQ-961)
* MB-138: Fix FindBugs issues (AMQ-1293)
* MB-137: ActiveMQ is not JMS 1.1 compliant regarding supporting foreign messages (AMQ-1275)
* MB-136: Sending messages to a topic with an inactive durable subscription will hang producers (AMQ-845)
* MB-135: Service Wrapper Installer does not work when ActiveMQ is installed on path that contains a spaces (AMQ-1274)
* MB-134: browse -QTopic=* does not seem to return anything... (AMQ-1050)
* MB-133: Broker fails to deliver messages after restart (AMQ-870)
* MB-132: java.lang.ClassCastException: org.apache.activemq.ActiveMQConnectionConsumer, when trying to publish to a topic (AMQ-1189)
* MB-131: Network conntions not shutdown propertly when a InvalidClientIDException occurs (AMQ-1343)
* MB-130: Topic destination created for channel:// destination name (AMQ-977)
* MB-129: Deadlock on ServerSessionImpl that hangs all connection consumers (AMQ-1267)
* MB-128: Topics allways created from the activemq-web module (AMQ-1266)
* MB-127: Deadlock in MutexTransport on shutdown with high volume of messages (AMQ-1119)
* MB-126: Invalid XSD (according to XML Spy) (AMQ-929)
* MB-125: consumer queue is empty when running requester (AMQ-1057)
* MB-124: StompSubscriptionRemoveTest hangs (AMQ-1323)
* MB-123: Connection leak in the PooledConnectionFactory (AMQ-1178)
* MB-122: Invalid Schema URL for example config file (AMQ-1014)
* MB-121: JDBC Master/Slave: After database failure, stale db connections are reused in DefaultdatabaseLocker (AMQ-1263)
* MB-120: Activemq connection factory silently ignores the erroneous arguments in broker url (AMQ-1071)
* MB-119: activemq-ra pom.xml's xbean plugin missing version (AMQ-1218)
* MB-118: activemq-rar-4.1.0-incubator.rar contains spring twice: spring-1.2.4.jar and spring-2.0.jar (AMQ-1124)
* MB-117: Start Broker SQL Exception (AMQ-1109)
* MB-116: Non-persistent messages on a Queue expire prior to TimeToLive for small values  (AMQ-1162)
* MB-115: Unused import sun.security.x509.IssuerAlternativeNameExtension prevents using IBM JDK for building ActiveMQ (AMQ-1279)
* MB-114: Compression not working  (AMQ-1140)
* MB-113: Spelling error in examples directory (AMQ-1289)
* MB-112: ActiveMQConnection memory leaks (AMQ-1177)
* MB-111: Slow consumer terminally blocks both client and broker (AMQ-1020)
* MB-110: Memory usage jumps > 100% with durable subscription and stays there (AMQ-1061)
* MB-109: Network connections do not reconnect when using static: with failover=true (AMQ-726) (AMQ-734)
* MB-108: Scheduler.cancel uses incorrect argument to shutdown threads (AMQ-1235)
* MB-107: Admin code has a minor bug - blank page in IE (AMQ-1245)
* MB-106: 4.0 M4 NullPointerException while shutting down (AMQ-528)
* MB-105: Sporatic ArrayOutOfBoundsException with Kaha persistence (in org.apache.activemq.kaha.impl.index.hash.HashPage.addHashEntry) (AMQ-1246)
* MB-104: MessageServletSupport does not compile (AMQ-1292)
* MB-103: Use of Temporary Destinations over broker networks can cause the network bridges to die. (AMQ-804)
* MB-102: Slow consumer causes producer to block on UsageManager.waitForSpace indefinately (AMQ-1136)
* MB-101: DestinationMap seems to use up lots of RAM if using deep hierarchies (AMQ-1068)
* MB-100: Failed to register MBean error. (AMQ-1044)
* MB-99: JMS to JMS Bridge fails with Number format exception on physical name (AMQ-1110)
* MB-98: Kaha DB hangs on restart (AMQ-1121)
* MB-97: SimpleNetworkTest hangs (AMQ-594)
* MB-96: Bad quotes on web page (AMQ-1258)
* MB-95: IllegalStateException thrown from QueueBrowserServlet (AMQ-1261)
* MB-94: Closing consumer does not free server memory, server heap overflows (AMQ-1062)
* MB-93: "TimeToLive" doesn't work on MessageListener (AMQ-1072)
* MB-92: 4.1 RC1: META-INF/spring.schemas refers to building user "file:/Users/chirino/" (AMQ-1016)
* MB-91: Messages are read from queue but not removed (AMQ-962)
* MB-90: Kaha can't be completely disabled in activemq-5.0 (AMQ-1294)
* MB-89: Client deadlock during failover (AMQ-1093)
* MB-88: NullPointerException when using MasterConnector and specifying the broker name with space in it. (AMQ-841)
* MB-87: create=false for vm://localhost causes Exception (AMQ-1128)
* MB-86: UsageManager leak when topic consumers are disconnected. (AMQ-1172)
* MB-85: StoreTest.testLock() fails due to java.io.IOException: The process cannot access the file because another process has locked a portion of the file on Windows (AMQ-1348)
* MB-84: oracle jdbc adapter has issues storing messages greater than 64k (AMQ-1216)
* MB-83: duplicate delivery, already consumed messages are reconsumed after server restart (AMQ-361)
* MB-82: Misbehaving consumer can affect message delivery to other consumers for a given topic. (AMQ-349)
* MB-81: TemporaryQueue communication not working (AMQ-1142)
* MB-80: Deadlock when ActiveMQ 4.X is run as an embedded broker inside JBoss 4.X with "<config-property-value>vm://localhost</config-property-value>" configured in the ra.xml file. (AMQ-1092)
* MB-79: Kaha Store puts a non-string into System properties (AMQ-1254)
* MB-78: Expired Messages being delivered (AMQ-936)
* MB-77: hasSpace call looks like it may cause messages to be skipped (AMQ-1080)
* MB-76: Pure Master/Slave configuration doesn't work (AMQ-1257)
* MB-75: avoid use of XHTML in activemq-web-console so things work great in IE 6 (AMQ-767)
* MB-74: Messages consumed with the Resource Adapter are intermittently not delivered (AMQ-1078)
* MB-73: Deadlock can occur when cerating and deleting many destinations concurrently (AMQ-1344)
* MB-72: 4.0 M4 Persistent Issue with network brokers (AMQ-527)
* MB-71: XA recover fails for 4.0.1 (AMQ-1054)
* MB-70: org.apache.activemq.broker.TransportConnection::stop should not attempt to send a message over the connection. (AMQ-771)
* MB-69: TransactionContext class cast exception (AMQ-1088)
* MB-68: PooledBrokerFactoryBean incorrectly compares broker config resources (AMQ-1106)
* MB-67: Broker Connection Shutdown is prone to lockup/deadlock (AMQ-1179)
* MB-66: OutOfMemoryError (AMQ-914)
* MB-65: Active MQ is creating great number of Oracle processes (AMQ-728)
* MB-64: Some tools from Command line not works properly (AMQ-1048)
* MB-63: Publishing to temporary Queues and advisorySupport="false" (AMQ-1256)
* MB-62: ActiveMQConsumer can catch an error in dispatch but logs it as a warning (AMQ-1113)
* MB-61: Illegal character in hostname error on hosts with underscores in their host names (AMQ-1188)
* MB-60: stomp connections in the broker don't get cleared up if the socket dies (AMQ-1134)
* MB-55: AMQ reports 'Async exception with no exception listener' upon shutdown of SMX

=== fuse-4.1.2.5 
* MB-247: Closed STOMP connection are not properly being released by the broker / JMS Clients hang at initial connection
* MB-59: Update maven poms to use the new maven repository http://repo.open.iona.com/
* MB-53: Enhanced the JMX view of the NetworkConnector

=== fuse-4.1.2.4 
* MB-58: Allow source to build with Maven 2.0.6
* MB-57: implement message priority dispatching
* MB-33: Messages consumed with the Resource Adapter (RA) are intermittently not delivered

===  fuse-4.1.2.2 
* MB-56: Make PooledBrokerFactoryBean work with spring 2.0
* MB-42: Message compression option is not compressing messages.

=== fuse-4.1.0.11 
* MB-247: Closed STOMP connection are not properly being released by the broker / JMS Clients hang at initial connection
* MB-59: Update maven poms to use the new maven repository http://repo.open.iona.com/

=== fuse-4.1.0.10 
* MB-54: Exclusive consumers are now selected up front when the consumer gets registered. (AMQ-1335)
* MB-53: Enhanced the JMX view of the NetworkConnector

=== fuse-4.1.0.9 
* MB-52: The ActiveMQ thread Scheduler leaks threads.
* MB-51: The InvalidClientIDException should say who whas establishing the connection
* MB-50: Multicast Discovery Agent can get into a tight loop reconnecting if the network connection fails to get established (AMQ-1342)
* MB-49: Give the connection threads names that are easy to associate with the peer.
* MB-48: Thread gets stuck in a WAIT and never returns (AMQ-1340)
* MB-47: Network conntions not shutdown propertly when a InvalidClientIDException occurs (AMQ-1343)
* MB-46: Broker should finish accepting connection in an async thread. (AMQ-1337)
* MB-45: If you 'Cannot lookup a connection that had not been registered' then we should also close out the connection since it can't fix itself.

=== fuse-4.1.0.8 
* MB-44: Deadlock could occur on shutdown
* MB-43: Don't allocate caches if caching is disabled in the OpenWire protocol
* MB-42: Message compression option is not compressing messages.
* MB-41: Deadlock can occur when cerating and deleting many destinations concurrently (AMQ-1344)
* MB-40: JMX tabula data could not view viewed. (viewing messages via JMX) 
* MB-39: A broker side connection could hang if the connection fails when the connection is being shutdown
* MB-38: A connection that is blocked on send due to queue limits could not be shutdown
* MB-37: Memory limits for topics was not returning to normal after it's consumers were disconnected
* MB-36: Disconnect failed connections quicker

=== fuse-4.1.0.7 
* MB-35: Mulitcast Discovery Agent should continue to advertise even if system clock is set backward in time
* MB-34: Enhanced JMX stats and attributes
* MB-33: Messages consumed with the Resource Adapter (RA) are intermittently not delivered
* MB-32: ActiveMQ Resource Adapter did not serialize properly when stored in JNDI
* MB-31: Add missing XBean annotation on ActiveMQManagedConnectionFactory
* MB-30: Sync oneway of a ShutdownInfo from the broker to the client could deadlock the vm transport
* MB-29: Temp reply to destinations do erroneously reported as not existing when using network of brokers
* MB-28: Avoid requiring a JMS client from subscribing to topic advisories
* MB-26: Thrown Nullpointer exception from ConnectionStateTracker can lead to stack overflow
* MB-25: The ActiveMQ PooledConnectionFactory continually created new connections
* MB-24: Network Connection leverage the non blocking sync sends implemented in MB-23
* MB-23: One blocked sync sender on a connection will not block another sync sender on the same connection.

=== fuse-4.1.0.6
* MB-22: DestinationMap exponentially uses more memory the deeper the destination hierarchy gets
* MB-20: PooledConnectionFactory does not work with the org.springframework.jms.listener.DefaultMessageListenerContainer in the failure case
* MB-19: The JMSConsumerTest interminitently failed on linux systems.
* MB-16: When client uses failover to reconnect to broker, broker state can get messed up when it has 2 concurrent connections.

=== fuse-4.1.0.4 
* MB-18: Message delivered out of order to a MessageListener when session is transacted and a rollback occurs.

=== fuse-4.1.0.3 
* MB-17: Add dispatch counter to JMX destination view (AMQ-1023)

=== fuse-4.1.0.2 
* MB-15: Log4j JMS Appender : Allows log4j log mesages to be sent over JMS
* MB-14: JMX Connector not created when there is an existing MBeanServer
* MB-13: Inactivity Monitor causes a InterruptedException in broker when connection is disconnected. (AMQ-983)
* MB-12: Source Builds are Broken
* MB-11: Support extending the activemq classpath with the ACTIVEMQ_CLASSPATH variable and overriding of the SUNJMX variable. (AMQ-938)
* MB-10: ssl:// protocol broken on the client side: get a java.net.SocketException: Unconnected sockets not implemented (AMQ-933)
* MB-9: Add a removeNetworkConnector() method to the BrokerService
* MB-8: Inactivity Monitor timeout does not on disconnected client does not cause blocked dispatch to client to fail. (AMQ-918)
* MB-7: Failover transport does not replay all the transaction operations on failover. (AMQ-915)
* MB-6: Transient connection failure with Failover transport can cause InvalidClientIDException (AMQ-911)
* MB-5: Clients and Brokers of different versions could not connect to each other.

=== fuse-4.1.0.1 
* MB-4: Timing bug could cause duplicate client id exception in network code. (AMQ-886)
* MB-3: Allow temp destination message bridging to be disable across demand based bridges. (AMQ-887)
* MB-2: Add NOT NULL contraint for ID column in ACTIVEMQ_LOCK table
